/**********************************************************************
  _v
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"


int	print_mems( struct MACHINE_RESOURCE *mres, int start_adrs , int leng )
{
int i,j ;
static char disp_str[16+2] ;
int dump_mem_adrs ;
int dump_length ;
unsigned char *mem ;

 dump_mem_adrs=lad(start_adrs) ;
 dump_length=leng ;
 
 disp_str[16]='\0' ;
 disp_str[17]='\0' ;

 mem=mres->mem[seg(start_adrs)] ;

 for( j=0 ; j<(dump_length/16) ; j++ ){
   fprintf(simmsgfp,"%08x :",(dump_mem_adrs|(seg(start_adrs)<<28))) ;
   for( i=0 ; i<16 ; i++ ){
     if( (isgraph( mem[dump_mem_adrs+i] )!=0) ||
	 (mem[dump_mem_adrs+i]==' ') ){
       disp_str[i]=mem[dump_mem_adrs+i] ;
     }else{
       disp_str[i]='.' ;
     }
     fprintf(simmsgfp," %02X",mem[dump_mem_adrs+i] ) ;
   }
   fprintf(simmsgfp," %s",disp_str) ;
   fprintf(simmsgfp,"\n") ;
   dump_mem_adrs+=16 ;
 }
 
 return(NORMAL_EXIT) ;
}
